unit libreta;
{$R lib.dcr}
interface

uses
  Messages, SysUtils,Graphics, Controls, Forms
  ,classes,stdctrls,extctrls;

type
  Tlibreta = class(Tcustompanel)
  private
    { Private declarations }
    fmemo:tmemo;
    anilla,esquina3,esquina1,lateral1,esquina2,lateral2:tbitmap;
    fcolorsheet:tcolor;
    fredline,freadonly:boolean;
    fmaxlength:integer;
    procedure setcolorsheet(colorsh:tcolor);
    procedure setredline (redl:boolean);
     {Eventos}
    procedure setondblclick(raton:tnotifyevent);
    function getondblclick:tnotifyevent;
    procedure setonclick(raton:tnotifyevent);
    function getonclick:tnotifyevent;
    procedure setonchange(chang:tnotifyevent);
    function getonchange:tnotifyevent;
    procedure setonexit(chang:tnotifyevent);
    function getonexit:tnotifyevent;
    procedure setonenter(chang:tnotifyevent);
    function getonenter:tnotifyevent;
    procedure setonmousemove(raton:TMouseMoveEvent);
    function getonmousemove:TMouseMoveEvent;
    procedure setonmouseup(raton:TMouseEvent);
    function getonmouseup:TMouseEvent;
    procedure setonmousedown(raton:TMouseEvent);
    function getonmousedown:TMouseEvent;
    procedure setonkeypressed(raton:TKeyPressEvent);
    function getonkeypressed:TKeyPressEvent;
       {Propiedades del texto}
    procedure settext(t:string);
    function gettext:string;
    procedure setfont(sfont:tfont);
    function getfont:tfont;
    procedure setreadonly(re:boolean);
    procedure setmaxlength(s:integer);
    procedure setlines(s:tstrings);
    function getlines :tstrings;

  protected
    { Protected declarations }
    procedure WMSize(var Message: TWMSize); message WM_SIZE;
    procedure Paint; override;
  public
    { Public declarations }
    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;
    property text:string read gettext write settext;
    procedure clear;
    procedure copytoclipboard;
    procedure cuttoclipboard;
    procedure pastefromclipboard;
    procedure selectall;

  published
    { Published declarations }
    property Colorsheet:Tcolor read fcolorsheet write setcolorsheet;
    property redline:boolean read fredline write setredline;
          {Eventos}
    property onclick:Tnotifyevent read getonclick write setonclick;
    property ondblclick:Tnotifyevent read getondblclick write setondblclick;
    property onchange:Tnotifyevent read getonchange write setonchange;
    property onenter:Tnotifyevent read getonenter write setonenter;
    property onexit:Tnotifyevent read getonexit write setonexit;
    property onKeypress:tkeypressevent read getonkeypressed write setonkeypressed;
    property onmouseup:TMouseEvent read getonmouseup write setonmouseup;
    property onmousedown:TMouseEvent read getonmousedown write setonmousedown;
    property onmousemove:TMouseMoveEvent read getonmousemove write setonmousemove;
          {propiedades del texto}
    property Font : tfont read getfont write setfont;
    property readonly : boolean read freadonly write setreadonly;
    property maxlength: integer read fmaxlength write setmaxlength;
    property lines : tstrings read getlines write setlines;
  end;

procedure Register;

implementation
{$R bitlibreta.res}
constructor Tlibreta.Create(AOwner: TComponent);

begin
  inherited Create(AOwner);

  { Valores por defecto de esta carpeta }
  Width  := 220;
  Height := 220;
  fcolorsheet:=clwhite;
  fredline:=true;
  freadonly:=false;
  parentcolor:=true;
  fmaxlength:=0;
  { Creo el tmemo }
  Fmemo := Tmemo.Create(Self);
  InsertControl(Fmemo);
  fmemo.borderstyle:=bsnone;
     {bitmap anilla}
  anilla:=tbitmap.create;
  anilla.loadfromresourcename(HInstance,'anilla');
  anilla.transparent:=true;
  anilla.transparentcolor:=anilla.Canvas.pixels[0,0];
     {bitmap esquina abajo-izquierda}
  esquina3:=tbitmap.create;
  esquina3.loadfromresourcename(HInstance,'esquina3');
  esquina3.transparent:=true;
  esquina3.transparentcolor:=anilla.Canvas.pixels[0,0];
     {bitmap esquina arriba-derecha}
  esquina1:=tbitmap.create;
  esquina1.loadfromresourcename(HInstance,'esquina1');
  esquina1.transparent:=true;
  esquina1.transparentcolor:=esquina1.Canvas.pixels[0,5];
    {bitmap lateral derecho}
  lateral1:=tbitmap.create;
  lateral1.loadfromresourcename(HInstance,'lateral1');
  lateral1.transparent:=true;
  lateral1.transparentcolor:=lateral1.Canvas.pixels[0,0];
   {bitmap esquina abajo-derecha}
  esquina2:=tbitmap.create;
  esquina2.loadfromresourcename(HInstance,'esquina2');
  esquina2.transparent:=true;
  esquina2.transparentcolor:=esquina2.Canvas.pixels[0,0];
     {bitmap lateral abajo}
  lateral2:=tbitmap.create;
  lateral2.loadfromresourcename(HInstance,'lateral2');
  lateral2.transparent:=true;
  lateral2.transparentcolor:=lateral2.Canvas.pixels[0,0];

  fmemo.top:=25;
  fmemo.left:=58;
  fmemo.height:=height-55;
  fmemo.width:=width -98;
end;
destructor Tlibreta.Destroy;
begin
  { Libero la memoria ocupada por el tmemo }
  Fmemo.free;
  anilla.free;
  esquina3.free;
  esquina1.free;
  lateral1.free;
  esquina2.free;
  inherited Destroy;
end;
procedure tlibreta.clear;
        begin
        fmemo.clear;
        end;
procedure tlibreta.copytoclipboard;
        begin
        fmemo.copytoclipboard;
        end;
procedure tlibreta.cuttoclipboard;
        begin
        fmemo.cuttoclipboard;
        end;
procedure tlibreta.pastefromclipboard;
        begin
        fmemo.pastefromclipboard;
        end;
procedure tlibreta.selectall;
        begin
        fmemo.selectall;
        end;
procedure tlibreta.setlines(s:tstrings);
        begin
        fmemo.lines:=s;
        end;
function tlibreta.getlines:tstrings;
        begin
        result:=fmemo.lines;
        end;


procedure tlibreta.setmaxlength(s:integer);
        begin
        fmemo.MaxLength:=s;
        fmaxlength:=s;
        end;
procedure tlibreta.setreadonly(re:boolean);
        begin
        fmemo.ReadOnly:=re;
        freadonly:=re;
        end;
procedure tlibreta.setfont(sfont:tfont);
        begin
        fmemo.font:=sfont;
        end;
function tlibreta.getfont:tfont;
        begin
        result:=fmemo.Font;
        end;
procedure tlibreta.settext(t:string);
        begin
        fmemo.text:=t;
        end;
function tlibreta.gettext:string;
        begin
        result:=fmemo.text;
        end;
procedure tlibreta.setcolorsheet(colorsh:tcolor);
        begin
        fcolorsheet:=colorsh;
        invalidate;
        end;
procedure tlibreta.setredline (redl:boolean);
        begin
        fredline:=redl;
        invalidate;
        end;
function tlibreta.getonclick:tnotifyevent;
        begin
        result:=fmemo.onclick;
        end;
procedure tlibreta.setonclick(raton:tnotifyevent);
        begin
        fmemo.onclick:=raton;
        end;
function tlibreta.getondblclick:tnotifyevent;
        begin
        result:=fmemo.ondblclick;
        end;
procedure tlibreta.setondblclick(raton:tnotifyevent);
        begin
        fmemo.ondblclick:=raton;
        end;

function tlibreta.getonkeypressed:tkeypressevent;
        begin
        result:=fmemo.onkeypress;
        end;
procedure tlibreta.setonkeypressed(raton:tkeypressevent);
        begin
        fmemo.onkeypress:=raton;
        end;

function tlibreta.getonchange:tnotifyevent;
        begin
        result:=fmemo.onchange;
        end;
procedure tlibreta.setonchange(chang:tnotifyevent);
        begin
        fmemo.onchange:=chang;
        end;
function tlibreta.getonenter:tnotifyevent;
        begin
        result:=fmemo.onenter;
        end;
procedure tlibreta.setonenter(chang:tnotifyevent);
        begin
        fmemo.onenter:=chang;
        end;
function tlibreta.getonexit:tnotifyevent;
        begin
        result:=fmemo.onexit;
        end;
procedure tlibreta.setonexit(chang:tnotifyevent);
        begin
        fmemo.onexit:=chang;
        end;



function tlibreta.getonmousemove:TMouseMoveEvent;
        begin
        result:=fmemo.OnMouseMove;
        end;
procedure tlibreta.setonmousemove(raton:tmousemoveevent);
        begin
        fmemo.onmousemove:=raton;
        end;
function tlibreta.getonmouseup:TMouseEvent;
        begin
        result:=fmemo.OnMouseup;
        end;
procedure tlibreta.setonmouseup(raton:tmouseevent);
        begin
        fmemo.onmouseup:=raton;
        end;
function tlibreta.getonmousedown:TMouseEvent;
        begin
        result:=fmemo.OnMousedown;
        end;
procedure tlibreta.setonmousedown(raton:tmouseevent);
        begin
        fmemo.onmousedown:=raton;
        end;


procedure Tlibreta.WMSize(var Message: TWMSize);
begin
  with Message do begin
    if Width < 115 then Self.Width := 115;
    if Height < 105 then Self.Height := 105;
    fmemo.top:=25;
    fmemo.left:=58;
    fmemo.height:=height-55;
    fmemo.width:=width -98;
    { Repinto... }
    Invalidate;
  end;
end;
procedure Tlibreta.Paint;
  var numbitmaps,n,n1:integer;

begin


  with Canvas do
   begin
   brush.style:=bssolid;
   brush.color:=fcolorsheet;
   fmemo.color:=fcolorsheet;
   pen.color:=clblack;
   pen.width:=2;
   rectangle(16,0,width,height);
   pen.width:=1;
   pen.color:=color;
   brush.color:= color;
   rectangle(0,0,15,height);
   rectangle(width-10,0,width,height);
   pen.color:=clred;
          {dibujo la linea roja}
   if fredline=true then begin
                     moveto(56,1);
                     lineto(56,height-15);
                         end;
          {dibujo los graficos de la libreta}
   numbitmaps:=height div 30;
   for n:= 0 to (numbitmaps-1) do
                begin
                draw(0,(30*n),anilla);
                end;
   numbitmaps:= (height-33) div 13 ;
   for n:= 0 to (numbitmaps) do
                begin
                n1:=(13*n)+13;
                if n1 >(height-33) then n1:=(height-33);
                draw(width-25,n1,lateral1);
                end;
     numbitmaps:= (width-58) div 30 ;
   for n:= 0 to (numbitmaps) do
                begin
                n1:=(n*30)+32;
                if n1 >(width-56) then n1:=(width-56);
                draw(n1,height-20,lateral2)
                end;

   draw (12,height-17,esquina3);
   draw (width-23,0,esquina1);
   draw (width-26,height-20,esquina2);
   end;
end;

procedure Register;
begin
  RegisterComponents('Samples', [Tlibreta]);
end;

end.
